void leer_tension ()
{
  volatile int voltaje = analogRead (lectura_voltaje); //Se lee el voltaje del pin 0 analogico

  voltaje_leido = map (voltaje, 0, 1023, 0, 500); //Se mapea entre 0-500 para despues dividir entre 100 y obtener un valor con dos difras decimales
  voltaje_leido = voltaje_leido / 100;            //Se pasa el valor con dos decimales

  voltaje_filtrado = voltaje_filtrado + (voltaje_leido - voltaje_filtrado)/ SAMPLES_TO_AVERAGE;  //Se actualiza la media
  
  voltaje_modificado = map (voltaje_filtrado, 0, 1023, 0, 100); //se hace mapea el voltaje para traducirlo a porcentaje

  if (voltaje_filtrado >= 1.88)
  {
    voltaje_filtrado = voltaje_filtrado*100; //Se vuelve a pasar con dos decimales para tener mayor precision
    volt_traducido_vumetro = map (voltaje_filtrado, 187, 500, 25, 255); //Se mapea el valor para poner un 0 cuando en la entrada haya 16 V y un 5 para cuando haya 0 V
    voltaje_filtrado = voltaje_filtrado/100;
  }
  else 
    volt_traducido_vumetro = 0; //Si la tension es menor que 16 V poner 0 V a la salida siempre

  analogWrite (tension_vumetro, volt_traducido_vumetro);

  Serial.print (voltaje_filtrado);
  Serial.print ("  ");
  Serial.println (volt_traducido_vumetro);
      
  if (voltaje_filtrado <= 2.60 && voltaje_filtrado >= 1.88) //Voltaje correspondiente a 25-16 V en los ultacondensadores para indicar que la carga esta baja
  {
    bateria_baja = 1;
    lcd.setCursor (7,1);
    lcd.print (" ");
    lcd.write (byte (0)); //Se imprime el primer caracter de la bateria 
    lcd.write (byte (1)); //Se imprime el segundo caracter de la bateria
    lcd.print (" ");
  } 
  else if (voltaje_filtrado < 1.88) //Voltaje por debajo de los 16 V que el boost ya no podria elevar a 36 V
    bateria_baja = 2;
  else
  {
    if (bateria_baja == 2) //se borra la pantalla para eliminar letras no deseadas
      lcd.clear ();
    else if (bateria_baja == 1) //Se borra el icono de la bateria
    {
      lcd.setCursor (8,1);
      lcd.print ("  ");
    }
    else
      bateria_baja = 0;
  }
}

