/* REALIZACIÓN DEL PID*/
void PID()
{
  nuevo_Automatico = FuncionamientoAutomatico;
  Ahora_PID = micros(); // Tiempo actual en el que se produce el PID
  dT = (Ahora_PID - tiempo_anterior_PID); // ASÍ SE GUARDA EN UNA VARIABLE EL TIEMPO DESDE QUE SE PRODUJO EL PID ANTERIOR Y EL NUEVO

  Error = (velocidad_rueda_trasera_final - velocidad_rueda_delantera_final); //  PARA CALCULAR EL ERROR O DIFERENCIA DE FLANCOS ASCENDENTES CONTABILIZADOS EN UN TIEMPO DETERMINADO ENTRE LAS RUEDAS

  if (nuevo_Automatico && !Automatico) // SI SE PROVIENE DE UN MODO DE DAR TENSIÓN AL CONTROLADOR DELANTERO QUE NO SEA MEDIANTE EL PID
  {
    Inicializar(); // Para inicializar el PID cada vez que pasemos de un modo de funcionamiento en el que no se utilice el PID
    //Serial.println("Inicializamos PID");
  }
  errorProp = kp * Error; // SE CALCULA LA PARTE PROPORCIONAL DEL PID
  // se limita el error proporcional
  if (errorProp > 3.8)
  {
    errorProp = 3.8; // Límite superior
  }
  else if (errorProp < -3.8)
  {
    errorProp = -3.8; // Límite inferior
  }
  errorsum += (Error * dT * ki / 1000000); // es igual que errorsum = errorsum + Error*dT*ki/1000000000 la división entre 1000000000 es para ponerlo en función de microsegundos
  // SE CALCULA LA PARTE INTEGRAL DEL PID
  //hay que limitar el error integral que es el errorsum
  if (errorsum > 3.8)
  {
    errorsum = 3.8; // Límite superior
  }
  else if (errorsum < 0.54)
  {
    errorsum = 0.54; // Límite inferior
  }
  errorDer = ((Error - Error_anterior) * kd) / dT; // no se multiplica por 1000000 porque kd lo va a absorber // SE CALCULA LA PARTE DERIVATIVA DEL PID

  // se limita el error derivativo
  if (errorDer > 2)
  {
    errorDer = 2; // Límite superior
  }
  else if (errorDer < -2)
  {
    errorDer = -2; // Límite inferior
  }
  salida = ((errorsum) + errorProp + errorDer); // LA SALIDA DEL PID TOTAL ES LA SUMA DE TODAS LOS TÉRMINOS, EL PROPORCIONAL, EL INTEGRAL Y EL DERIVATIVO
  //hay que limitar la salida total

  if (salida > 3.8)
  {
    salida = 3.8; // Límite superior
  }
  else if (salida < 0.54)
  {
    salida = 0.54; // Límite inferior
  }
  else
  {
    //No se hace nada pues se queda como está
  }

  velocidad_RD_float = ((salida * (31.4)) + 80); // SE TRADUCE ESA SEÑAL DE TENSIÓN A VALORES ENTRE 0 Y 255 (0 Y 5 VOLTIOS) Y SE REALIZA DE ESTA FORMA PARA QUE AMBOS MOTORES EMPIECEN A FUNCIONAR A LA VEZ
  velocidad_RD_int = velocidad_RD_float;
  if (velocidad_RD_float - velocidad_RD_int > 0.5)
  {
    velocidad_RD_int += 1;
  }

  velocidad_RD_int = constrain(velocidad_RD_int, 0, 165); // Se limita la señal a comandar al motor delantero
  Mandar_al_controlador();
  //--------------------------------------------------
  Error_anterior = Error; // Se guarda la diferencia de flancos ascendentes anterior
  Automatico = nuevo_Automatico;
  tiempo_anterior_PID = Ahora_PID; // Se guarda el tiempo en el que se realizó el último PID
}
/* FIN REALIZACIÓN DEL PID*/
